/*
 *    Copyright [2011] [wisemapping]
 *
 *   Licensed under WiseMapping Public License, Version 1.0 (the "License").
 *   It is basically the Apache License, Version 2.0 (the "License") plus the
 *   "powered by wisemapping" text requirement on every single page;
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the license at
 *
 *       http://www.wisemapping.org/license
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

mindplot.model.LinkModel = new Class({
    initialize : function(url, topic) {
        $assert(url, 'url can not be null');
        $assert(topic, 'mindmap can not be null');
        this._topic = topic;
        this.setUrl(url);
    },

    getUrl : function() {
        return this._url;
    },

    setUrl : function(url) {
        $assert(url, 'url can not be null');
        this._url = this._fixUrl(url);
        this._type = this._url.contains('mailto:') ? 'mail' : 'url';
    },

    getTopic : function() {
        return this._topic;
    },

    isLinkModel : function() {
        return true;
    }
    ,
    _fixUrl : function(url) {
        var result = url;
        if (!result.contains('http://') && !result.contains('https://') && !result.contains('mailto://')) {
            result = "http://" + result;
        }
        return result;
    }
});